"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypiaPatchWizard = void 0;
var fs_1 = __importDefault(require("fs"));
var TypiaPatchWizard;
(function (TypiaPatchWizard) {
    var _this = this;
    TypiaPatchWizard.main = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("----------------------------------------");
                    console.log(" Typia Setup Wizard");
                    console.log("----------------------------------------");
                    console.log([
                        "Since TypeScript v5.3 update, \"tsc\" no more parses JSDoc comments.",
                        "",
                        "Therefore, \"typia\" revives the JSDoc parsing feature by patching \"tsc\".",
                        "",
                        "This is a temporary feature of \"typia\", and it would be removed when \"ts-patch\" being updated.",
                    ].join("\n"));
                    return [4, TypiaPatchWizard.patch()];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    }); };
    TypiaPatchWizard.patch = function () { return __awaiter(_this, void 0, void 0, function () {
        var location, content;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    location = require.resolve("typescript/lib/tsc.js");
                    return [4, fs_1.default.promises.readFile(location, "utf8")];
                case 1:
                    content = _a.sent();
                    if (!(content.indexOf(FROM_WITH_COMMENT) !== -1)) return [3, 3];
                    return [4, fs_1.default.promises.writeFile(location, content.replace(FROM_WITH_COMMENT, TO_WITH_COMMENT), "utf8")];
                case 2:
                    _a.sent();
                    return [3, 5];
                case 3:
                    if (!(content.indexOf(FROM_ONLY) !== -1)) return [3, 5];
                    return [4, fs_1.default.promises.writeFile(location, content.replace(FROM_ONLY, TO_ONLY), "utf8")];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5: return [2];
            }
        });
    }); };
})(TypiaPatchWizard || (exports.TypiaPatchWizard = TypiaPatchWizard = {}));
var FROM_WITH_COMMENT = "var defaultJSDocParsingMode = 2 /* ParseForTypeErrors */";
var TO_WITH_COMMENT = "var defaultJSDocParsingMode = 0 /* ParseAll */";
var FROM_ONLY = "var defaultJSDocParsingMode = 2";
var TO_ONLY = "var defaultJSDocParsingMode = 0";
//# sourceMappingURL=TypiaPatchWizard.js.map