"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iterate_metadata_array = void 0;
var MetadataArray_1 = require("../../../schemas/metadata/MetadataArray");
var ArrayUtil_1 = require("../../../utils/ArrayUtil");
var emplace_metadata_array_type_1 = require("./emplace_metadata_array_type");
var iterate_metadata_array = function (checker) {
    return function (options) {
        return function (collection) {
            return function (errors) {
                return function (meta, type, explore) {
                    if (!checker.isArrayType(type))
                        return false;
                    var arrayType = (0, emplace_metadata_array_type_1.emplace_metadata_array_type)(checker)(options)(collection)(errors)(type, meta.nullable, explore);
                    ArrayUtil_1.ArrayUtil.add(meta.arrays, MetadataArray_1.MetadataArray.create({
                        type: arrayType,
                        tags: [],
                    }), function (elem) { return elem.type.name === arrayType.name; });
                    return true;
                };
            };
        };
    };
};
exports.iterate_metadata_array = iterate_metadata_array;
//# sourceMappingURL=iterate_metadata_array.js.map