"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$ParameterReader = void 0;
var $ParameterReader;
(function ($ParameterReader) {
    $ParameterReader.boolean = function (value) {
        return value !== "null"
            ? value === "true" || value === "1"
                ? true
                : value === "false" || value === "0"
                    ? false
                    : value
            : null;
    };
    $ParameterReader.bigint = function (value) {
        return value !== "null" ? toBigint(value) : null;
    };
    $ParameterReader.number = function (value) {
        return value !== "null" ? toNumber(value) : null;
    };
    $ParameterReader.string = function (value) { return (value !== "null" ? value : null); };
})($ParameterReader || (exports.$ParameterReader = $ParameterReader = {}));
var toNumber = function (str) {
    var value = Number(str);
    return isNaN(value) ? str : value;
};
var toBigint = function (str) {
    try {
        return BigInt(str);
    }
    catch (_a) {
        return str;
    }
};
//# sourceMappingURL=$ParameterReader.js.map