"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$QueryReader = void 0;
var $QueryReader;
(function ($QueryReader) {
    $QueryReader.boolean = function (str) {
        return str === null
            ? undefined
            : str === "null"
                ? null
                : str.length === 0
                    ? true
                    : str === "true" || str === "1"
                        ? true
                        : str === "false" || str === "0"
                            ? false
                            : str;
    };
    $QueryReader.number = function (str) {
        return !!(str === null || str === void 0 ? void 0 : str.length)
            ? str === "null"
                ? null
                : toNumber(str)
            : undefined;
    };
    $QueryReader.bigint = function (str) {
        return !!(str === null || str === void 0 ? void 0 : str.length)
            ? str === "null"
                ? null
                : toBigint(str)
            : undefined;
    };
    $QueryReader.string = function (str) {
        return str === null ? undefined : str === "null" ? null : str;
    };
    $QueryReader.params = function (input) {
        if (typeof input === "string") {
            var index = input.indexOf("?");
            input = index === -1 ? "" : input.substring(index + 1);
            return new URLSearchParams(input);
        }
        return input;
    };
    $QueryReader.array = function (input, alternative) {
        return input.length ? input : alternative;
    };
})($QueryReader || (exports.$QueryReader = $QueryReader = {}));
var toNumber = function (str) {
    var value = Number(str);
    return isNaN(value) ? str : value;
};
var toBigint = function (str) {
    try {
        return BigInt(str);
    }
    catch (_a) {
        return str;
    }
};
//# sourceMappingURL=$QueryReader.js.map