"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.application_alias = void 0;
var CommentFactory_1 = require("../../factories/CommentFactory");
var JSON_SCHEMA_PREFIX_1 = require("./JSON_SCHEMA_PREFIX");
var application_object_1 = require("./application_object");
var application_schema_1 = require("./application_schema");
var application_alias = function (options) {
    return function (blockNever) {
        return function (components) {
            return function (alias) {
                return function (nullable) {
                    var _a, _b, _c, _d, _e;
                    if (alias.value.size() === 1 && alias.value.objects.length === 1)
                        return (0, application_object_1.application_object)(options)(components)(alias.value.objects[0])(nullable);
                    var key = options.purpose === "ajv"
                        ? alias.name
                        : "".concat(alias.name).concat(nullable ? ".Nullable" : "");
                    var $id = "".concat(JSON_SCHEMA_PREFIX_1.JSON_COMPONENTS_PREFIX, "/schemas/").concat(key);
                    if (((_a = components.schemas) === null || _a === void 0 ? void 0 : _a[key]) === undefined) {
                        (_b = components.schemas) !== null && _b !== void 0 ? _b : (components.schemas = {});
                        components.schemas[key] = {
                            $id: key,
                        };
                        var schema = (0, application_schema_1.application_schema)(options)(blockNever)(components)(alias.value)({
                            deprecated: alias.jsDocTags.some(function (tag) { return tag.name === "deprecated"; }) || undefined,
                            title: (function () {
                                var _a;
                                var info = alias.jsDocTags.find(function (tag) { return tag.name === "title"; });
                                return ((_a = info === null || info === void 0 ? void 0 : info.text) === null || _a === void 0 ? void 0 : _a.length)
                                    ? CommentFactory_1.CommentFactory.merge(info.text)
                                    : undefined;
                            })(),
                            description: (_c = alias.description) !== null && _c !== void 0 ? _c : undefined,
                            "x-typia-jsDocTags": (function () {
                                var filtered = alias.jsDocTags.filter(function (tag) {
                                    return tag.name !== "title" &&
                                        tag.name !== "deprecated" &&
                                        tag.name !== "hidden";
                                });
                                return filtered.length ? filtered : undefined;
                            })(),
                        });
                        if (options.surplus === false && ((_d = schema["x-typia-jsDocTags"]) === null || _d === void 0 ? void 0 : _d.length))
                            delete schema["x-typia-jsDocTags"];
                        (_e = components.schemas) !== null && _e !== void 0 ? _e : (components.schemas = {});
                        components.schemas[key] = __assign({ $id: options.purpose === "ajv" ? $id : undefined, $recursiveAnchor: (options.purpose === "ajv" && alias.recursive) || undefined }, schema);
                    }
                    return { $ref: $id };
                };
            };
        };
    };
};
exports.application_alias = application_alias;
//# sourceMappingURL=application_alias.js.map