"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.application_array = void 0;
var application_schema_1 = require("./application_schema");
var application_array = function (options) {
    return function (components) {
        return function (array) {
            var items = (0, application_schema_1.application_schema)(options)(false)(components)(array.type.value)({});
            var base = {
                type: "array",
                items: null,
            };
            var out = function (schema) {
                schema.items = items;
                return schema;
            };
            if (array.tags.length === 0)
                return [out(base)];
            var union = array.tags.map(function (row) { return application_array_tags(options)(__assign({}, base))(row); });
            var map = new Map(union.map(function (u) { return [JSON.stringify(u), u]; }));
            return __spreadArray([], __read(map.values()), false).map(function (s) { return out(s); });
        };
    };
};
exports.application_array = application_array;
var application_array_tags = function (options) {
    return function (schema) {
        return function (row) {
            var e_1, _a;
            try {
                for (var _b = __values(row.slice().sort(function (a, b) { return a.kind.localeCompare(b.kind); })), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var tag = _c.value;
                    if (tag.kind === "minItems" && typeof tag.value === "number")
                        schema.minItems = tag.value;
                    else if (tag.kind === "maxItems" && typeof tag.value === "number")
                        schema.maxItems = tag.value;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (options.surplus)
                schema["x-typia-typeTags"] = row.map(function (tag) { return ({
                    target: tag.target,
                    name: tag.name,
                    kind: tag.kind,
                    value: tag.value,
                    validate: tag.validate,
                    exclusive: tag.exclusive,
                }); });
            return schema;
        };
    };
};
//# sourceMappingURL=application_array.js.map