"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.application_constant = void 0;
var application_default_1 = require("./application_default");
var application_constant = function (constant) {
    return function (attribute) { return ({
        type: constant.type,
        enum: constant.values,
        default: (0, application_default_1.application_default)(attribute)(function (alias) {
            return constant.values.some(function (v) { return v.toString() === alias; });
        })(constant.type === "string"
            ? function (str) { return str; }
            : constant.type === "number"
                ? function (str) { return Number(str); }
                : constant.type === "boolean"
                    ? function (str) { return Boolean(str); }
                    : function (str) { return BigInt(str); }),
    }); };
};
exports.application_constant = application_constant;
//# sourceMappingURL=application_constant.js.map