"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.application_number = void 0;
var application_default_1 = require("./application_default");
var application_number = function (options) {
    return function (atomic) {
        return function (attribute) {
            var base = {
                type: "number",
            };
            var out = function (schema) {
                var _a;
                (_a = schema.default) !== null && _a !== void 0 ? _a : (schema.default = (0, application_default_1.application_default)(attribute)(function (str) {
                    var value = Number(str);
                    var conditions = [!Number.isNaN(value)];
                    if (schema.minimum !== undefined)
                        if (schema.exclusiveMinimum === true)
                            conditions.push(value > schema.minimum);
                        else
                            conditions.push(value >= schema.minimum);
                    if (schema.maximum !== undefined)
                        if (schema.exclusiveMaximum === true)
                            conditions.push(value < schema.maximum);
                        else
                            conditions.push(value <= schema.maximum);
                    if (schema.multipleOf !== undefined)
                        conditions.push(value % schema.multipleOf === 0);
                    return conditions.every(function (cond) { return cond; });
                })(function (str) { return Number(str); }));
                return schema;
            };
            if (atomic.tags.length === 0)
                return [out(base)];
            var union = atomic.tags.map(function (row) { return application_number_tags(options)(__assign({}, base))(row); });
            var map = new Map(union.map(function (u) { return [JSON.stringify(u), u]; }));
            return __spreadArray([], __read(map.values()), false).map(function (s) { return out(s); });
        };
    };
};
exports.application_number = application_number;
var application_number_tags = function (options) {
    return function (base) {
        return function (row) {
            var e_1, _a;
            try {
                for (var _b = __values(row
                    .slice()
                    .sort(function (a, b) { return a.kind.localeCompare(b.kind); })), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var tag = _c.value;
                    if (tag.kind === "type" &&
                        (tag.value === "int32" ||
                            tag.value === "uint32" ||
                            tag.value === "int64" ||
                            tag.value === "uint64"))
                        base.type = "integer";
                    else if (tag.kind === "minimum" && typeof tag.value === "number")
                        base.minimum = tag.value;
                    else if (tag.kind === "maximum" && typeof tag.value === "number")
                        base.maximum = tag.value;
                    else if (tag.kind === "exclusiveMinimum" &&
                        typeof tag.value === "number") {
                        base.minimum = tag.value;
                        base.exclusiveMinimum = true;
                    }
                    else if (tag.kind === "exclusiveMaximum" &&
                        typeof tag.value === "number") {
                        base.maximum = tag.value;
                        base.exclusiveMaximum = true;
                    }
                    else if (tag.kind === "multipleOf" && typeof tag.value === "number")
                        base.multipleOf = tag.value;
                    else if (tag.kind === "default" && typeof tag.value === "number")
                        base.default = tag.value;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (options.surplus)
                base["x-typia-typeTags"] = row.map(function (tag) { return ({
                    target: tag.target,
                    name: tag.name,
                    kind: tag.kind,
                    value: tag.value,
                    validate: tag.validate,
                    exclusive: tag.exclusive,
                }); });
            return base;
        };
    };
};
//# sourceMappingURL=application_number.js.map