"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonApplicationProgrammer = void 0;
var TransformerError_1 = require("../../transformers/TransformerError");
var application_schema_1 = require("../internal/application_schema");
var JsonApplicationProgrammer;
(function (JsonApplicationProgrammer) {
    var IOptions;
    (function (IOptions) {
        IOptions.complement = function (options) {
            var _a, _b;
            return ({
                purpose: (_a = options === null || options === void 0 ? void 0 : options.purpose) !== null && _a !== void 0 ? _a : "swagger",
                surplus: (_b = options === null || options === void 0 ? void 0 : options.surplus) !== null && _b !== void 0 ? _b : false,
            });
        };
    })(IOptions = JsonApplicationProgrammer.IOptions || (JsonApplicationProgrammer.IOptions = {}));
    JsonApplicationProgrammer.write = function (options) {
        return function (metadatas) {
            var fullOptions = IOptions.complement(options);
            var components = {
                schemas: {},
            };
            var generator = (0, application_schema_1.application_schema)(fullOptions)(true)(components);
            return __assign({ schemas: metadatas.map(function (meta, i) {
                    var schema = generator(meta)({});
                    if (schema === null)
                        throw new TransformerError_1.TransformerError({
                            code: "typia.json.application",
                            message: "invalid type on argument - (".concat(meta.getName(), ", ").concat(i, ")"),
                        });
                    return schema;
                }), components: components }, fullOptions);
        };
    };
})(JsonApplicationProgrammer || (exports.JsonApplicationProgrammer = JsonApplicationProgrammer = {}));
//# sourceMappingURL=JsonApplicationProgrammer.js.map