"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RandomGenerator = void 0;
var randexp_1 = __importDefault(require("randexp"));
var RandomGenerator;
(function (RandomGenerator) {
    var ALPHABETS = "abcdefghijklmnopqrstuvwxyz";
    RandomGenerator.boolean = function () { return Math.random() < 0.5; };
    RandomGenerator.integer = function (min, max) {
        min !== null && min !== void 0 ? min : (min = 0);
        max !== null && max !== void 0 ? max : (max = 100);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };
    RandomGenerator.bigint = function (min, max) {
        min !== null && min !== void 0 ? min : (min = BigInt(0));
        max !== null && max !== void 0 ? max : (max = BigInt(100));
        return BigInt(RandomGenerator.integer(Number(min), Number(max)));
    };
    RandomGenerator.number = function (min, max) {
        min !== null && min !== void 0 ? min : (min = 0);
        max !== null && max !== void 0 ? max : (max = 100);
        return Math.random() * (max - min) + min;
    };
    RandomGenerator.string = function (length) {
        return new Array(length !== null && length !== void 0 ? length : RandomGenerator.integer(5, 10))
            .fill(0)
            .map(function () { return ALPHABETS[RandomGenerator.integer(0, ALPHABETS.length - 1)]; })
            .join("");
    };
    RandomGenerator.array = function (closure, count) {
        return new Array(count !== null && count !== void 0 ? count : RandomGenerator.length()).fill(0).map(function (_e, index) { return closure(index); });
    };
    RandomGenerator.pick = function (array) {
        return array[RandomGenerator.integer(0, array.length - 1)];
    };
    RandomGenerator.length = function () { return RandomGenerator.integer(0, 3); };
    RandomGenerator.uuid = function () {
        return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
            var r = (Math.random() * 16) | 0;
            var v = c === "x" ? r : (r & 0x3) | 0x8;
            return v.toString(16);
        });
    };
    RandomGenerator.email = function () { return "".concat(RandomGenerator.string(10), "@").concat(RandomGenerator.string(10), ".").concat(RandomGenerator.string(3)); };
    RandomGenerator.url = function () { return "https://".concat(RandomGenerator.string(10), ".").concat(RandomGenerator.string(3)); };
    RandomGenerator.ipv4 = function () { return RandomGenerator.array(function () { return RandomGenerator.integer(0, 255); }, 4).join("."); };
    RandomGenerator.ipv6 = function () {
        return RandomGenerator.array(function () { return RandomGenerator.integer(0, 65535).toString(16); }, 8).join(":");
    };
    RandomGenerator.pattern = function (regex) { return new randexp_1.default(regex).gen(); };
    RandomGenerator.date = function (min, max) {
        min !== null && min !== void 0 ? min : (min = 0);
        max !== null && max !== void 0 ? max : (max = Date.now() * 2);
        return new Date(RandomGenerator.number(min, max)).toISOString().substring(0, 10);
    };
    RandomGenerator.datetime = function (min, max) {
        min !== null && min !== void 0 ? min : (min = Date.now() - 30 * DAY);
        max !== null && max !== void 0 ? max : (max = Date.now() + 7 * DAY);
        return new Date(RandomGenerator.number(min, max)).toISOString();
    };
})(RandomGenerator || (exports.RandomGenerator = RandomGenerator = {}));
var DAY = 1000 * 60 * 60 * 24;
//# sourceMappingURL=RandomGenerator.js.map