import { TypeGuardError } from "../TypeGuardError";

/**
 * @internal
 */
export const $number = (value: number): number => {
  if (isFinite(value) === false)
    throw new TypeGuardError({
      method: "typia.json.stringify",
      expected: "number",
      value,
      message: "Error on typia.json.stringify(): infinite or not a number.",
    });
  return value;
};
